# SmartEverything Lion - loRa IoT transmission
----

This is a library for the Microchip RN2483 loRaWAN component.

Microchip’s RN2483 Low-Power Long Range LoRa Technology Transceiver module
provides an easy to use, low-power solution for long range wireless data transmission. 
The advanced command interface offers rapid time to market.
The RN2483 module complies with the LoRaWAN Class A protocol specifications. 
It integrates RF, a baseband controller, command Application Programming Interface (API) processor, 
making it a complete long range Solution.

The RN2483 module is suitable for simple long range sensor applications with external host MCU.


[* Microchip RN2483 Home Page *](http://www.microchip.com/wwwproducts/en/RN2483)


It was principally designed to work with the SmartEverything Lion board, but could
be easily adapted and used on every Arduino and Arduino Certified boards.

Provided by <development@axelelettronica.it>.

## Repository Contents
-------------------
* **/examples** - Example sketches for the library (.ino). Run these from the Arduino IDE.
* **/src** - Source files for the library (.cpp, .h).
* **library.properties** - General library properties for the Arduino package manager.

## Releases  
---  
#### v1.1.0 Second Release  
* **Maintenance Release:**  
    Added more Examples.  
 
#### v1.0.0 First Release  
* **First development:**  
    Added main infrastructure.  
 
## Documentation
--------------

* **[Installing an Arduino Library Guide](http://www.arduino.cc/en/Guide/Libraries#toc3)** - How to install a SmartEverything library on the Arduino IDE using the Library Manager


## License Information
-------------------

Copyright (c) Amel Technology. All right reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
